
//   logical a(80)
// !hpf$ processors q(2, 3)
// !hpf$ template s(4, 100)
// !hpf$ distribute s(block, cyclic(12)) onto q
// !hpf$ align a(j) with s(2, 15 + j) 
// 
//   do i = 1, 80
//     a(i) = .false.
//   enddo
// 
//   print '(2l3,i4)', any(a), all(a), count(a)
// 
//   a(12) = .true.
//   a(25) = .true.
//   a(2)  = .true.
//   a(17) = .true.
// 
//   print '(2l3,i4)', any(a), all(a), count(a)
// 
//   do i = 1, 80
//     a(i) = .true.
//   enddo
// 
//   print '(2l3,i4)', any(a), all(a), count(a)
// end

//#include <stdio.h>
#include "ad++.h"

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 q(2, 3) ;

  BlockRange s1(4, q.dim(0)) ;
  BlockCyclicRange s2(100, q.dim(1), 12) ;

  Group r = q / s1(1) ;
  Range x = s2.subrng(80, 15) ;

  Array1<int> a(x, r) ;

  Index i(x) ;

  ON(r) {
    OVERALL(i) {
      a(i) = 0 ;
    } ALLOVER(i) ;
  } NO(p) ;

  gprintf("%3d%3d%4d\n", any(a), all(a), count(a)) ;

  ON(r) {
     Location j ;

     j = x(11) ;
     AT(j) {
       a(j) = 1 ;
     } TA(j) ;

     j = x(24) ;
     AT(j) {
       a(j) = 1 ;
     } TA(j) ;

     j = x(1) ;
     AT(j) {
       a(j) = 1 ;
     } TA(j) ;

     j = x(16) ;
     AT(j) {
       a(j) = 1 ;
     } TA(j) ;
  } NO(p) ;

  gprintf("%3d%3d%4d\n", any(a), all(a), count(a)) ;

  ON(r) {
    OVERALL(i) {
      a(i) = 1 ;
    } ALLOVER(i) ;
  } NO(p) ;

  gprintf("%3d%3d%4d\n", any(a), all(a), count(a)) ;

  AdlibFinalize() ;
}


